import { CheckBoxProps as GrommetCheckBoxProps } from 'grommet';
import * as React from 'react';
import { DefaultProps, Omit, RenditionSystemProps } from '../../common-types';
export declare const getHoverStyle: (props: any) => string;
export interface InternalCheckboxProps extends DefaultProps, Omit<GrommetCheckBoxProps, 'onChange'> {
    onChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
}
export declare type CheckboxProps = InternalCheckboxProps & RenditionSystemProps;
declare const _default: React.FunctionComponent<CheckboxProps>;
export default _default;
