import { JSONSchema6 } from 'json-schema';
import * as arrayType from './array';
import * as booleanType from './boolean';
import * as dateTimeType from './date-time';
import * as enumType from './enum';
import * as numberType from './number';
import * as objectType from './object';
import * as oneOfType from './oneOf';
import * as stringType from './string';
export declare const getDataModel: (schema?: JSONSchema6 | undefined) => typeof arrayType | typeof booleanType | typeof dateTimeType | typeof enumType | typeof numberType | typeof objectType | typeof oneOfType | typeof stringType | null;
