"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var faBars_1 = require("@fortawesome/free-solid-svg-icons/faBars");
var faTimes_1 = require("@fortawesome/free-solid-svg-icons/faTimes");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var assign_1 = __importDefault(require("lodash/assign"));
var React = __importStar(require("react"));
var recompose_1 = require("recompose");
var styled_components_1 = __importDefault(require("styled-components"));
var Box_1 = require("../Box");
var Container_1 = __importDefault(require("../Container"));
var Flex_1 = require("../Flex");
var BrandBox = styled_components_1.default(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: flex;\n\talign-self: center;\n"], ["\n\tdisplay: flex;\n\talign-self: center;\n"])));
var IconBox = styled_components_1.default(Box_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\talign-self: center;\n\tcursor: pointer;\n"], ["\n\talign-self: center;\n\tcursor: pointer;\n"])));
var MenuBox = styled_components_1.default(Flex_1.Flex)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\ttext-align: center;\n\ttransition: max-height 0.4s ease-in-out;\n\talign-self: center;\n\toverflow: hidden;\n\n\ta {\n\t\twidth: 100%;\n\t\tdisplay: inline-block;\n\t}\n"], ["\n\ttext-align: center;\n\ttransition: max-height 0.4s ease-in-out;\n\talign-self: center;\n\toverflow: hidden;\n\n\ta {\n\t\twidth: 100%;\n\t\tdisplay: inline-block;\n\t}\n"])));
var Navbar = (function (_super) {
    __extends(Navbar, _super);
    function Navbar(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            open: false,
        };
        return _this;
    }
    Navbar.prototype.toggle = function () {
        this.setState({
            open: !this.state.open,
        });
    };
    Navbar.prototype.render = function () {
        var _this = this;
        var _a = this.props, brand = _a.brand, children = _a.children, props = __rest(_a, ["brand", "children"]);
        return (React.createElement(Box_1.Box, __assign({}, props),
            React.createElement(Container_1.default, null,
                React.createElement(Flex_1.Flex, { flexDirection: ['column', 'row'] },
                    React.createElement(Flex_1.Flex, null,
                        React.createElement(BrandBox, { minWidth: "150px", height: "auto", p: 2 }, brand),
                        children && (React.createElement(IconBox, { onClick: function () { return _this.toggle(); }, ml: ['auto', 0], p: 2, display: ['block', 'none'] }, this.state.open ? (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimes_1.faTimes })) : (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faBars_1.faBars }))))),
                    React.createElement(MenuBox, { maxHeight: [this.state.open ? '100vh' : '0vh', 'none'], width: ['100%', 'auto'], ml: [0, 'auto'] }, children && (React.createElement(Flex_1.Flex, { width: ['100%', 'auto'], flexDirection: ['column', 'row'] }, React.Children.map(children, function (child, i) {
                        return (React.createElement(Box_1.Box, { onClick: function () { return _this.toggle(); }, width: ['100%', 'auto'], p: 2, key: i }, child));
                    }))))))));
    };
    return Navbar;
}(React.Component));
var setDefaultProps = recompose_1.withProps(function (props) {
    return assign_1.default({
        color: 'white',
        bg: 'gray.dark',
    }, props);
});
exports.default = recompose_1.compose(setDefaultProps)(Navbar);
var templateObject_1, templateObject_2, templateObject_3;
