"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(require("./colorUtils"));
__export(require("./schemaUtils"));
__export(require("./styledUtils"));
var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
exports.randomString = function (length) {
    if (length === void 0) { length = 16; }
    var text = '';
    var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    for (var i = 0; i < length; i++) {
        text += possible.charAt(Math.floor(Math.random() * possible.length));
    }
    return text;
};
exports.regexEscape = function (str) {
    return str.replace(matchOperatorsRe, '\\$&');
};
