import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
import { FlexProps } from '../Flex';
declare const _default: ({ content, show, children, onClick, ...otherProps }: InternalCopyProps) => JSX.Element;
export default _default;
export interface InternalCopyProps extends Omit<FlexProps, 'onClick'> {
    content: string;
    show?: 'hover' | 'always';
    onClick?: (content: string) => void;
    children?: React.ReactNode;
}
export declare type CopyProps = InternalCopyProps & RenditionSystemProps;
